import java.util.ArrayList;
import java.util.LinkedList;

public class NewsFeed {

    public NewsFeed(){
    }

    public LinkedList<Edge> getSingleMemberUnsortedNewsFeed(Member viewer){
	LinkedList<Edge> scoredEdges = new LinkedList<Edge>();
	int selfAffinity = 1;
	ArrayList el = new ArrayList(viewer.getEdgeStack().popAll());
	for (int i = 0; i<el.size(); i++){
	    Edge currentEdge = (Edge)el.get(i);
	    System.out.println(currentEdge.toString());
	    if ((currentEdge.getItem().getType()==1)||(currentEdge.getItem().getType()==4)){
		int erScore = 0;
		for (int j = 0; j<el.size(); j++){
		    Edge scanEdge =(Edge) el.get(j);
		    
		    if ((scanEdge.getReference().getItemID()==currentEdge.getItem().getItemID())||
			(scanEdge.getItem().getItemID()==currentEdge.getItem().getItemID())){
			erScore = erScore 
			    + selfAffinity
			    * getWeight(scanEdge.getItem().getType())
			    * getTimeDecay(scanEdge.getItem().getAge());
		    }
		    
		}
		currentEdge.setEdgeRankScore(erScore);
		scoredEdges.add(currentEdge);


	    }
	}
    
	return scoredEdges;	
    }

    public LinkedList<Edge> getSingleMemberSortedNewsFeed(LinkedList<Edge> unsortedList){
	// add your code here
    }


    public int getWeight(int type){
	int weight = 0;
	if (type==1) return 4;
	if (type==2) return 3;
	if (type==3) return 0; // does not happen
	if (type==4) return 5;
	if (type==5) return 2;
	if (type==1) return 1;
	
	return 0;
    }
    public int getTimeDecay(int age){
	int timedecay = 0;
	if ((0<age)&&(age<=60)) timedecay = 6;
	if ((60<age)&&(age<=180)) timedecay = 5;
	if ((180<age)&&(age<=360)) timedecay = 4;
	if ((360<age)&&(age<=720)) timedecay = 3;
	if ((720<age)&&(age<=1440)) timedecay = 2;
	if ((1440<age)&&(age<=2880)) timedecay = 1;	
	return timedecay;
    }
    
    public static void main(String[] args){
	
    }
	
}